const
  MaxDescLength = 4096;

  DT_Floppy525_360     = 0;
  DT_Floppy525_12      = 1;
  DT_Floppy35_720      = 2;
  DT_Floppy525_8SD     = 3;
  DT_Floppy525_8DD     = 4;
  DT_HardDisk          = 5;
  DT_TapeDrive         = 6;
  DT_Floppy35_144      = 7;
  DT_Optical           = 8;
  DT_Floppy35_288      = 9;
  DT_CDROM             = 10;
  DT_Network           = 11;
  DT_RamDisk           = 12;
  DT_Removable         = 13;
  DT_ZipDrive          = 14;
  DT_JazDrive          = 15;
  DT_ZipDrivePlus      = 16;
  DT_SeagateDirectTape = 17;
  DT_LS120             = 18;
  DT_MOS320            = 19;
  DT_MOS332            = 20;
  DT_M2531A            = 21;
  DT_Jaz2Drive         = 22;
  DT_Unknown           = $FF;

type
  TPluginType = (ptReserved, ptSameFile, ptParentItem, ptItemList, ptDiskInfo);

  TDescInfoRecord = record
    lpszRootPath: PChar;
    lpszVirtualRoot: PChar;
    lpszVolumeLabel: PChar;
    lpszFSName: PChar;
    iMaxNameLength: Integer;
    dwSerialNumber: DWORD;
    wDiskNum: Word;
    wMediaType: Word;
    iBytesPerSector: Integer;
    iSectorsPerCluster: Integer;
    iTotalClusters: Integer;
    iFreeClusters: Integer;
    iNumberOfFiles: Integer;
    iNumberOfCompressedFiles: Integer;
    wNumberOfDirs: Word;
  end;

  TModuleInfo = procedure(ModuleName, Author, Version: PChar); stdcall;

  TConfigPluginProc = procedure(HInstance: THandle; OwnerWnd: THandle;
     PluginID: Word); stdcall;

  TRegisterPlugin = function (PluginID: Word; PluginType: TPluginType; PluginName,
     FileMask: PChar; ConfigProc: TConfigPluginProc): Integer; stdcall;

  TRegisterDescPlugins = procedure (RegisterPlugin: TRegisterPlugin); stdcall;

  TInitDescImport = procedure; stdcall;

  TDoneDescImport = procedure; stdcall;

  TRequireFileProc = function(FileName: PChar): PChar; stdcall;

  TImportDesc_SameFile = function(PluginID: Word; FileName,Desc: PChar;
     RequireFile: TRequireFileProc): Boolean; stdcall;

  TImportDesc_ParentItem = function(PluginID: Word; ParentName,FoundList,Desc: PChar;
     RequireFile: TRequireFileProc): Boolean; stdcall;

  TStoreDescProc = function(FileName, Desc: PChar): Boolean; stdcall;

  TImportDesc_ItemList = procedure(PluginID: Word; ParentName,FoundList: PChar;
     RequireFile: TRequireFileProc; StoreDescProc: TStoreDescProc); stdcall;

  TImportDesc_DiskInfoProc = function(PluginID: Word; DescInfo: TDescInfoRecord;
     Desc: PChar): Boolean; stdcall;